7714ef26ab06874dab2dfdd824ff597d5f4d2ac7
[grml-autoconfig.git] / autoconfig.functions
1 #!/bin/zsh
2 # Filename:      autoconfig.functions
3 # Purpose:       basic system configuration and hardware setup for grml system
4 # Authors:       grml-team (grml.org), (c) Klaus Knopper <knopper@knopper.net>, (c) Michael Prokop <mika@grml.org>
5 # Bug-Reports:   see http://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2.
7 # Latest change: Mon Nov 27 21:02:23 CET 2006 [mika]
8 ################################################################################
9
10 # {{{ path, variables, signals, umask, zsh
11 export PATH="/bin:/sbin:/usr/bin:/usr/sbin:/usr/X11R6/bin"
12 DEBUG="/dev/null"
13 KERNEL="$(uname -r)"
14 umask 022
15
16 # Ignore these signals in non-interactive mode: INT, TERM, SEGV
17 [ -z "$PS1" ] && trap "" 2 3 11
18
19 # zsh stuff
20 iszsh(){
21 if [ -n "$ZSH_VERSION" ] ; then
22   return 0
23 else
24   return 1
25 fi
26 }
27 # avoid 'no matches found: ...'
28 iszsh && setopt no_nomatch # || echo "Warning: not running under zsh!"
29 # }}}
30
31 ### {{{ Utility Functions
32
33 # Simple shell grep
34 stringinfile(){
35   case "$(cat $2)" in *$1*) return 0;; esac
36   return 1
37 }
38
39 # same for strings
40 stringinstring(){
41   case "$2" in *$1*) return 0;; esac
42   return 1
43 }
44
45 # Reread boot command line; echo last parameter's argument or return false.
46 getbootparam(){
47   stringinstring " $1=" "$CMDLINE" || return 1
48   result="${CMDLINE##*$1=}"
49   result="${result%%[   ]*}"
50   echo "$result"
51   return 0
52 }
53
54 # Check boot commandline for specified option
55 checkbootparam(){
56   stringinstring " $1" "$CMDLINE"
57   return "$?"
58 }
59
60 checkvalue(){
61   if [ "$1" = "yes" ] ; then
62     return 0
63   else
64     return 1
65   fi
66 }
67
68 checkgrmlsmall(){
69   grep -q small /etc/grml_version 2>>$DEBUG && return 0 || return 1
70 }
71
72 checkgrmlusb(){
73   grep -q usb /etc/grml_version 2>>$DEBUG && return 0 || return 1
74 }
75 ### }}}
76
77 # {{{ filesystems (proc, pts, sys) and fixes
78 mount_proc(){
79   [ -f /proc/version ] || mount -t proc /proc /proc 2>/dev/null
80 }
81
82 mount_pts(){
83   stringinfile "/dev/pts" /proc/mounts || mount -t devpts /dev/pts /dev/pts 2>/dev/null
84 }
85
86 mount_sys(){
87   [ -d /sys/devices ] || mount -t sysfs /sys /sys 2>/dev/null
88 }
89 # }}}
90
91 # {{{ Read in boot parameters
92 [ -f /proc/version ] || mount_proc # make sure we can access /proc/cmdline when sourcing this file too
93 CMDLINE="$(cat /proc/cmdline)"
94 [ -d /cdrom/bootparams/ ] && CMDLINE="$CMDLINE $(cat /cdrom/bootparams/* | tr '\n' ' ')"
95 # }}}
96
97 # {{{ Check if we are running from the grml-CD or HD
98 INSTALLED=""
99 [ -e /GRML/etc/grml_cd ] || INSTALLED="yes"
100
101 # testcd
102 TESTCD=""
103 checkbootparam "testcd" >>$DEBUG 2>&1 && TESTCD="yes"
104 # }}}
105
106 # {{{ source lsb-functions , color handling
107 if checkbootparam "nocolor"; then
108   RC_NOCOLOR=yes
109   . /etc/grml/lsb-functions
110   einfo "Disabling colors in bootsequence as requested on commandline." ; eend 0
111 else
112   . /etc/grml/lsb-functions
113   . /etc/grml_colors
114 fi
115 # }}}
116
117 # {{{ debug
118 config_debug(){
119  if checkbootparam "debug"; then
120    BOOTDEBUG="yes"
121  fi
122  if stringinstring "BOOT_IMAGE=debug " "$CMDLINE" ; then
123    BOOTDEBUG="yes"
124  fi
125  rundebugshell(){
126   if [ -n "$BOOTDEBUG" ]; then
127     einfo "Starting intermediate shell stage $stage as requested by \"debug\" option."
128     eindent
129     if [ -r /etc/grml/screenrc ] ; then
130        einfo "Starting GNU screen to be able to use a full featured shell environment."
131        einfo "Just exit the shells (and therefore screen) to continue boot process..."
132        /bin/zsh -c "screen -c /etc/grml/screenrc"
133     else
134       einfo "Notice that the shell does not provide job handling: ctrl-z, bg and fg won't work!"
135       einfo "Just exit the shell to continue boot process..."
136       /bin/zsh
137     fi
138     eoutdent
139   fi
140  }
141 }
142 # }}}
143
144 # {{{ log
145 config_log(){
146 if checkbootparam "log"; then
147   export DEBUG="/tmp/grml.log.`date +%Y%m%d`"
148   touch $DEBUG
149   einfo "Bootparameter log found. Log files: ${DEBUG} and /var/log/boot."
150   eindent
151     einfo "Starting bootlogd."
152     bootlogd -r -c 1>>$DEBUG 2>&1 ; eend $?
153   eoutdent
154 else
155   DEBUG="/dev/null"
156 fi
157 }
158 # }}}
159
160 # {{{ Check if we are in interactive startup mode
161 INTERACTIVE=""
162 stringinstring "BOOT_IMAGE=expert " "$CMDLINE" && INTERACTIVE="yes"
163 # }}}
164
165 # {{{ set firmware timeout via bootparam
166 config_fwtimeout(){
167  if checkbootparam fwtimeout ; then
168    TIMEOUT="$(getbootparam 'fwtimeout' 2>>$DEBUG)"
169    einfo "Bootoption fwtimeout found. (Re)Loading firmware_class module."
170    rmmod firmware_class 1>>$DEBUG 2>&1
171    modprobe firmware_class ; eend $?
172  fi
173  if [ -z "$TIMEOUT" ] ; then
174    TIMEOUT="100" # linux kernel default: 10
175  fi
176  if [ -f /sys/class/firmware/timeout ] ; then
177    einfo "Setting timeout for firmware loading to ${TIMEOUT}."
178    echo 100 > /sys/class/firmware/timeout ; eend $?
179  fi
180 }
181 # }}}
182
183 ### {{{ language configuration / localization
184 config_language(){
185
186  einfo "Activating language settings:"
187  eindent
188
189  # people can specify $LANGUAGE and $CONSOLEFONT in a config file:
190  [ -r /etc/grml/autoconfig ] && . /etc/grml/autoconfig
191
192  grep -q ' lang=.*-utf8' /proc/cmdline && UTF8='yes' || UTF8=''
193
194  # check for bootoption which overrides config from /etc/grml/autoconfig:
195  BOOT_LANGUAGE="$(getbootparam lang 2>>$DEBUG)"
196  [ -n "$BOOT_LANGUAGE" ] && LANGUAGE="$BOOT_LANGUAGE"
197
198  # set default to 'en' in live-cd mode if $LANGUAGE is not yet set:
199  if [ -z "$INSTALLED" ] ; then
200     [ -n "$LANGUAGE" ] || LANGUAGE='en-utf8'
201  fi
202
203  # if bootoption lang is used update /etc/default/locale, otherwise *not*!
204  if [ -n "$BOOT_LANGUAGE" ] ; then
205     [ -x /usr/sbin/grml-setlang ] && /usr/sbin/grml-setlang "$LANGUAGE"
206  fi
207
208  # set console font
209  if [ -z "$CONSOLEFONT" ] ; then
210     if ! checkbootparam "nodefaultfont" >>$DEBUG 2>&1 ; then
211        # [ -n "$UTF8" ] && CONSOLEFONT='LatArCyrHeb-16' || CONSOLEFONT='Lat15-Terminus16'
212        # if [ -r /usr/share/consolefonts/Lat15-Terminus16.psf.gz ] ; then
213        if [ -r /usr/share/consolefonts/Uni3-Terminus14.psf.gz ] ; then
214           CONSOLEFONT='Uni3-Terminus14'
215        else
216           ewarn "/usr/share/consolefonts/Uni3-Terminus14.psf.gz not available. Please upgrade package console-terminus." ; eend 1
217        fi
218     fi
219  fi
220
221  # export it now, so error messages get translated, too
222  if checkgrmlsmall ; then
223     export LANG='C' # grml-small does not provide any further locales
224  else
225     [ -r /etc/default/locale ] && . /etc/default/locale
226     export LANG LANGUAGE
227  fi
228
229  # configure keyboard layout, read in already set values first:
230  [ -r /etc/sysconfig/keyboard ] && . /etc/sysconfig/keyboard
231
232  # now allow keyboard override by boot commandline for later use:
233  KKEYBOARD="$(getbootparam keyboard 2>>$DEBUG)"
234  [ -n "$KKEYBOARD" ] && KEYTABLE="$KKEYBOARD"
235  # notce: de/at is a bad choice, so take de-latin1-nodeadkeys instead:
236  [[ "$KKEYBOARD" == 'de' ]] && KEYTABLE=de-latin1-nodeadkeys
237  [[ "$KKEYBOARD" == 'at' ]] && KEYTABLE=de-latin1-nodeadkeys
238
239  # modify /etc/sysconfig/keyboard only in live-cd mode:
240  if [ -z "$INSTALLED" ] ; then
241
242    local LANGUAGE="$BOOT_LANGUAGE"
243    . /etc/grml/language-functions
244    # allow setting xkeyboard explicitly different than console keyboard
245    KXKEYBOARD="$(getbootparam xkeyboard 2>>$DEBUG)"
246    if [ -n "$KXKEYBOARD" ]; then
247       XKEYBOARD="$KXKEYBOARD"
248       KDEKEYBOARD="$KXKEYBOARD"
249    elif [ -n "$KKEYBOARD" ]; then
250       XKEYBOARD="$KKEYBOARD"
251       KDEKEYBOARD="$KKEYBOARD"
252    fi
253
254    # duplicate of previous code to make sure /etc/grml/language-functions
255    # does not overwrite our values....
256    # now allow keyboard override by boot commandline for later use:
257    KKEYBOARD="$(getbootparam keyboard 2>>$DEBUG)"
258    [ -n "$KKEYBOARD" ] && KEYTABLE="$KKEYBOARD"
259    # notce: de/at is a bad choice, so take de-latin1-nodeadkeys instead:
260    [[ "$KKEYBOARD" == 'de' ]] && KEYTABLE=de-latin1-nodeadkeys
261    [[ "$KKEYBOARD" == 'at' ]] && KEYTABLE=de-latin1-nodeadkeys
262
263    # write keyboard related variables to file for later use
264    echo "KEYTABLE=\"$KEYTABLE\""          > /etc/sysconfig/keyboard
265    echo "XKEYBOARD=\"$XKEYBOARD\""       >> /etc/sysconfig/keyboard
266    echo "KDEKEYBOARD=\"$KDEKEYBOARD\""   >> /etc/sysconfig/keyboard
267    echo "KDEKEYBOARDS=\"$KDEKEYBOARDS\"" >> /etc/sysconfig/keyboard
268  fi
269
270  [ -r /etc/sysconfig/keyboard ] && . /etc/sysconfig/keyboard
271
272   # Set default keyboard before interactive setup
273   if [ -n "$KEYTABLE" ] ; then
274    einfo "Running loadkeys for ${WHITE}${KEYTABLE}${NORMAL} in background"
275    loadkeys -q $KEYTABLE &
276    eend $?
277   fi
278
279   if [ -n "$CONSOLEFONT" ] ; then
280      einfo "Running consolechars using ${CONSOLEFONT}"
281      consolechars -f $CONSOLEFONT || consolechars -d
282      eend $?
283
284 #     if [ -n "$UTF8" ] ; then
285 #        einfo "Notice: run 'filterm - dynafont' in your shell to enable a unicode capable console."
286 #     fi
287   fi
288
289   # we have to set up all consoles, therefore loop it over all ttys:
290   if [ -n "$CHARMAP" ] ; then
291    einfo "Running consolechars for ${CHARMAP}"
292    NUM_CONSOLES=`fgconsole --next-available`
293    NUM_CONSOLES=`expr ${NUM_CONSOLES} - 1`
294    [ ${NUM_CONSOLES} -eq 1 ] && NUM_CONSOLES=6
295    for vc in `seq 0 ${NUM_CONSOLES}`  ; do
296      consolechars --tty=/dev/tty${vc} -m ${CHARMAP} ; RC=$?
297    done
298    eend ${RC}
299   fi
300
301  eoutdent
302 }
303 # }}}
304
305 # {{{ Set hostname
306 config_hostname(){
307  if checkbootparam hostname ; then
308   HOSTNAME="$(getbootparam 'hostname' 2>>$DEBUG)"
309   einfo "Setting hostname to $HOSTNAME as requested."
310   sed -i "s/^127.0.0.1.*localhost/127.0.0.1 $HOSTNAME localhost/" /etc/hosts
311   hostname $HOSTNAME ; eend $?
312  else
313   hostname --file /etc/hostname
314  fi
315 }
316 # }}}
317
318 # fstabuser (needed when running from harddisk with username != grml {{{
319 config_userfstab(){
320   [ -r /etc/grml/autoconfig ] && . /etc/grml/autoconfig
321   if [ -n "$CONFIG_FSTAB_USER" ] ; then
322      fstabuser="$CONFIG_FSTAB_USER"
323   else
324      fstabuser=$(getent passwd 1000 | cut -d: -f1)
325   fi
326   # if not yet set fall back to default 'grml' user
327   [ -n "$fstabuser" ] || fstabuser='grml'
328 }
329 # }}}
330
331 # {{{ Set clock (Local time is more often used than GMT, so it is default)
332 config_time(){
333  # don't touch the files if running from harddisk:
334  if [ -z "$INSTALLED" ]; then
335   UTC=""
336   checkbootparam utc >>$DEBUG 2>&1 && UTC="-u"
337   checkbootparam gmt >>$DEBUG 2>&1 && UTC="-u"
338   # hwclock uses the TZ variable
339   if [ -r /etc/default/locale ] ; then
340      . /etc/default/locale
341   else
342      TZ=Europe/Vienna
343   fi
344   ERROR=$(TZ="$TZ" hwclock $UTC -s 2>&1) ; RC=$?
345   if [ -n "$ERROR" ] ; then
346      eindent
347      ERROR=$(TZ="$TZ" hwclock $UTC -s --directisa 2>&1)
348      if [ -n "$ERROR" ] ; then
349         eerror "Problem running hwclock: $ERROR" ; eend 1
350      fi
351      eoutdent
352   fi
353  fi
354 }
355 # }}}
356
357 # {{{ print kernel info
358 config_kernel(){
359   vmware-detect &>/dev/null && VMWARE="inside ${WHITE}VMWare${NORMAL}"
360   einfo "Running Linux Kernel $KERNEL $VMWARE" ; eend 0
361 }
362 # }}}
363
364 # {{{ vmware specific stuff
365 config_vmware(){
366 if checkbootparam novmware ; then
367  ewarn "Skipping running vmware specific stuff as requested on boot commandline." ; eend 0
368 else
369  if [ -z "$INSTALLED" ]; then
370   if vmware-detect ; then
371     if [ -r /etc/X11/xorg.conf.vmware ] ; then
372       einfo "Copying /etc/X11/xorg.conf.vmware to /etc/X11/xorg.conf"
373       cp /etc/X11/xorg.conf.vmware /etc/X11/xorg.conf ; eend $?
374     fi
375   fi
376  fi
377 fi
378 }
379 # }}}
380
381 # {{{ ld.so.cache + depmod
382 config_ld_mod(){
383 if [ -n "$INSTALLED" ]; then
384  if ! [ -r /etc/grml.first.boot ] ; then
385   einfo "Running from HD for the first time, regenerate ld.so.cache and modules.dep:"
386   eindent
387 # Regenerate ld.so.cache and module dependencies on HD
388     einfo "Running ldconfig" ; ldconfig  ; eend $?
389     einfo "Running depmod"   ; depmod -a ; eend $?
390     touch /etc/grml.first.boot
391     eend 0
392   eoutdent
393  fi
394 fi
395 }
396 # }}}
397
398 # update_progress {{{
399 update_progress(){
400   # be sure we are non-blocking
401   (echo "$1" > /etc/sysconfig/progress) &
402 }
403 # }}}
404
405 # {{{ timezone
406 config_timezone(){
407  # don't touch the files if running from harddisk:
408  if [ -z "$INSTALLED" ]; then
409   einfo "Setting timezone."
410   KTZ="$(getbootparam tz 2>>$DEBUG)"
411   [ -f "/usr/share/zoneinfo/$KTZ" ] && TZ="$KTZ"
412   rm -f /etc/localtime
413   cp "/usr/share/zoneinfo/$TZ" /etc/localtime && eend 0
414  fi
415 }
416 # }}}
417
418 # small computer / nearly no ram {{{
419 config_small(){
420
421 RAM=$(/usr/bin/gawk '/MemTotal/{print $2}' /proc/meminfo)
422 # MEM=$(/usr/bin/gawk 'BEGIN{m=0};/MemFree|Cached|SwapFree/{m+=$2};END{print m}' /proc/meminfo)
423 eindent
424
425 if checkbootparam "small"; then
426   einfo "Information: ${RAM} kB of RAM available." ; eend 0
427   einfo "Bootoption small detected. Activating small system."
428   if [ -r /etc/inittab.small ] ; then
429     mv /etc/inittab /etc/inittab.normal
430     mv /etc/inittab.small /etc/inittab
431   else
432     sed -i 's/^9/#&/' /etc/inittab
433     sed -i 's/^10/#&/' /etc/inittab
434     sed -i 's/^11/#&/' /etc/inittab
435     sed -i 's/^12/#&/' /etc/inittab
436   fi
437   /sbin/telinit q ; eend $?
438 else
439   if checkgrmlsmall ; then
440     if [[ $RAM -lt 25000 ]] ; then
441       ewarn "Information: ${RAM} kB of RAM available." ; eend 1
442       ewarn "At least 32MB of RAM should be available for grml-small." ; eend 1
443       ewarn "Use the bootoption small to save some more MB of memory usage." ; eend 0
444       ewarn "Dropping you into a rescue shell. To continue booting exit the shell." ; eend 0
445       /bin/zsh --login
446     else
447       einfo "Information: ${RAM} kB of RAM available." ; eend 0
448     fi
449   else
450     if [[ $RAM -lt 58000 ]] ; then
451       ewarn "Information: ${RAM} kB of RAM available." ; eend 1
452       ewarn "At least 64MB of RAM should be available for grml." ; eend 1
453       ewarn "Use the bootoption small to save some more MB of memory usage." ; eend 0
454       ewarn "Dropping you into a rescue shell. To continue booting exit the shell." ; eend 0
455       /bin/zsh --login
456     else
457       einfo "Information: ${RAM} kB of RAM available." ; eend 0
458     fi
459   fi
460 fi
461 eoutdent
462 }
463 # }}}
464
465 # skip startup of w3m {{{
466 config_fast(){
467 if checkbootparam "fast"; then
468   ewarn "Bootoption fast detected. Skipping startup of w3m."
469     sed -i 's#^1:.*#1:12345:respawn:/usr/bin/openvt -f -c 1 -w -- /bin/zsh#' /etc/inittab
470   /sbin/telinit q ; eend $?
471 fi
472 }
473 # }}}
474
475 # activate serial console {{{
476 config_console(){
477 if checkbootparam "console"; then
478   einfo "Bootoption (for serial) console detected. Activating mgetty."
479     sed -i 's/^#T0/T0/' /etc/inittab
480     sed -i 's/^#T1/T1/' /etc/inittab
481   /sbin/telinit q ; eend $?
482 fi
483 }
484 # }}}
485
486 # For burning on IDE-CD-Roms, k3b (and others) check for special permissions {{{
487 config_cdrom_perm(){
488 CDROMS=""
489 for DEVICE in /proc/ide/hd?; do
490  [ "$(cat $DEVICE/media 2>/dev/null)" = "cdrom" ] && CDROMS="$CDROMS /dev/${DEVICE##*/}"
491 done
492 [ -n "$CDROMS" ] && { chown root.cdrom $CDROMS; chmod 666 $CDROMS; } 2>/dev/null
493 }
494 # }}}
495
496 # {{{ Bring up loopback interface now
497 config_local_net(){
498  if [ -z "$INSTALLED" ] ; then
499     grep -q lo=lo /etc/network/run/ifstate 2>/dev/null || ifup lo
500  fi
501 }
502 # }}}
503
504 # firewire devices {{{
505 # the raw1394 driver does not yet export info into SYSFS,
506 # so let's create raw1394 device manually
507 # http://www.michael-prokop.at/blog/index.php?p=352
508 config_firewire_dev(){
509 if checkbootparam "nofirewiredev" ; then
510   ewarn "Skipping creating some firewire devices as requested on boot commandline." ; eend 0
511 else
512 #if [ "${KERNEL%-*}" == "2.6.11" ] ; then
513   einfo "Creating some firewire devices (fix kernel 2.6-bug)."
514 #  cd /dev && MAKEDEV video1394 raw1394
515   [ -r /dev/raw1394 ]   || mknod /dev/raw1394 c 171 0
516   [ -r /dev/video1394 ] || mknod -m 666 /dev/video1394 c 171 16
517 # mknod -m 666 /dev/dv1394 c 171 32 # for NTSC
518   [ -r /dev/dv1394 ]    || mknod -m 666 /dev/dv1394 c 171 34 # for PAL
519   chown -R root:video /dev/raw1394 /dev/video1394 /dev/dv1394
520   chmod -R 664 /dev/raw1394 /dev/video1394 /dev/dv1394 ; eend $?
521 fi
522 #fi
523 }
524 # }}}
525
526 # {{{ copy passwd-lockfile to ramdisk (fix unionfs-behaviour)
527 # otherwise we will get: passwd: Authentication token lock busy
528 config_fix_passwd(){
529  if [ -z "$INSTALLED" ] ; then
530   touch /etc/.pwd.lock
531  fi
532 }
533 # }}}
534
535 # {{{ CD Checker
536 config_testcd(){
537 if [ -n "$TESTCD" ]; then
538   einfo "Checking CD data integrity as requested by '${WHITE}testcd${NORMAL}' boot option."
539   einfo "Reading files and checking against GRML/md5sums, this may take a while..."
540   echo -n "${RED}"
541   ( cd /cdrom/GRML/ ; rm -f /tmp/md5sum.log ; md5sum -c md5sums 2>&1 | tee /tmp/md5sum.log )
542   if [ "$?" = "0" ]; then
543     echo " ${GREEN}Everything looks OK${NORMAL}"
544     else
545     echo "${RED} *** CHECKSUM FAILED FOR THESE FILES:                          ***"
546     egrep -v '(^md5sum:|OK$)' /tmp/md5sum.log
547     echo "${RED} *** DATA ON YOUR CD MEDIUM IS POSSIBLY INCOMPLETE OR DAMAGED, ***${NORMAL}"
548     echo "${RED} *** OR YOUR COMPUTER HAS BAD RAM.                             ***${NORMAL}"
549     echo -n "${CYAN}Hit return to contine, or press the reset button to quit.${NORMAL}\a\a\a "
550     read a
551   fi
552   eend 0
553 fi
554 }
555 # }}}
556
557 # {{{ hardware detection via discover
558 config_discover(){
559 if checkbootparam "nodisc" ; then
560   ewarn "Skipping hardware detection via discover as requested on boot commandline." ; eend 0
561 else
562  if [ -x /sbin/discover ] ; then
563   einfo "Discovering hardware. Trying to load the following modules in background:"
564    eindent
565    einfo "$(discover --data-path=linux/module/name --data-path=linux/modules/options --format="%s %s" --data-version=`uname -r` --enable-bus all | sort -u | xargs echo)"
566    eoutdent
567   /sbin/discover-modprobe -v 1>>$DEBUG 2>&1 &
568   eend 0
569  else
570   eerror "Application discover not available. Information: udev should handle hardware recognition." ; eend 0
571  fi
572 fi
573 }
574 # }}}
575
576 # {{{ hardware detection via hwinfo
577 config_hwinfo(){
578 if checkbootparam hwinfo >>$DEBUG 2>&1; then
579   einfo "Discovering hardware via hwinfo:"
580   MODULES=$(su grml hwinfo | grep "Cmd: \"modprobe" | awk '{print $5}' | sed 's/"//')
581   echo -n "  Loading modules: "
582   for i in `echo $MODULES` ; do echo -n $i && modprobe $i ; done
583   eend 0
584 fi
585 }
586 # }}}
587
588 # {{{ disable hotplug agents on request
589 config_hotplug_agent(){
590 if checkbootparam "noagent" ; then
591   AGENT="$(getbootparam 'noagent' 2>>$DEBUG)"
592   AGENTLIST=$(echo "$AGENT" | sed 's/,/\\n/g')
593   AGENTNL=$(echo "$AGENT" | sed 's/,/ /g')
594   einfo "Disabling hotplug-agent(s) $AGENTNL"
595   for agent in $(echo -e $AGENTLIST) ; do
596     mv /etc/hotplug/${agent}.rc /etc/hotplug/${agent}.norc
597   done
598   [ "$?" == "0" ] ; eend $?
599 fi
600 }
601 # }}}
602
603 # {{{ blacklist of hotplug-modules
604 config_hotplug_blacklist(){
605 if checkbootparam "black" ; then
606   BLACK="$(getbootparam 'black' 2>>$DEBUG)"
607   BLACKLIST=$(echo "$BLACK" | sed 's/,/\\n/g')
608   BLACKNL=$(echo "$BLACK" | sed 's/,/ /g')
609   einfo "Blacklisting $BLACKNL via /etc/hotplug/blacklist.d/hotplug-light"
610   echo -e "$BLACKLIST" >> /etc/hotplug/blacklist.d/hotplug-light
611   echo -e "$BLACKLIST" >> /etc/hotplug/blacklist
612   eend 0
613 fi
614 }
615 # }}}
616
617 # {{{ run hotplug
618 config_hotplug(){
619 if checkbootparam "nohotplug" ; then
620   ewarn "Skipping running hotplug as requested on boot commandline." ; eend 0
621 else
622   if [ -r /etc/init.d/hotplug ] ; then
623     einfo "Starting hotplug system in background."
624     /etc/init.d/hotplug start 1>>$DEBUG 2>>$DEBUG &
625     eend 0
626   elif [ -r /etc/init.d/hotplug-light ] ; then
627     einfo "Starting hotplug-light system in background."
628     /etc/init.d/hotplug-light start 1>>$DEBUG 2>>$DEBUG &
629     eend 0
630   else
631     ewarn "No hotplug system found. Should be handled by udev. Skipping execution." ; eend 0
632   fi
633 fi
634 }
635 # }}}
636
637 # {{{ blacklist specific module [ used in /etc/init.d/udev ]
638 config_blacklist(){
639 if checkbootparam "blacklist" ; then
640  if [ -z "$INSTALLED" ]; then
641   einfo "Bootoption blacklist found."
642   BLACK="$(getbootparam 'blacklist' 2>>$DEBUG)"
643   if [ -n "$BLACK" ] ; then
644     einfo "Blacklisting module ${BLACK} via /etc/modprobe.d/grml."
645     echo "# begin entry generated by config_blacklist of grml-autoconfig" >> /etc/modprobe.d/grml
646     echo "blacklist $BLACK"     >> /etc/modprobe.d/grml
647     echo "alias     $BLACK off" >> /etc/modprobe.d/grml
648     echo "# end   entry generated by config_blacklist of grml-autoconfig" >> /etc/modprobe.d/grml ; eend $?
649   else
650    eerror "No given module for blacklist found. Blacklisting will not work therefor."
651   fi
652  else
653   ewarn "Backlisting via bootoption does not work on harddisk installations." ; eend 1
654   eindent
655    einfo "Please blacklist the module(s) via /etc/modprobe.d/blacklist."
656   eoutdent
657  fi
658 fi
659 }
660 # }}}
661
662 # {{{ ACPI
663 config_acpi_apm(){
664 if [ -d /proc/acpi ]; then
665   if checkbootparam "noacpi"; then
666     ewarn "Skipping ACPI Bios detection as requested on boot commandline." ; eend 0
667   else
668     einfo "ACPI Bios found, activating modules: "
669     eindent
670     found=""
671     for a in /lib/modules/$KERNEL/kernel/drivers/acpi/*; do
672       basename="${a##*/}"
673       basename="${basename%%.*}"
674       case "$basename" in *_acpi)
675        egrep -qi "${basename%%_acpi}" /proc/acpi/dsdt 2>>$DEBUG || continue ;;
676       esac
677       modprobe $basename >>$DEBUG 2>&1 && found="yes"
678       local BASE="$BASE $basename"
679     done
680     if [ -n "$found" ] ; then
681       einfo "$BASE"  ; eend 0
682     else
683       ewarn "(none)" ; eend 1
684     fi
685     if ! [ -S /var/run/acpid.socket ] ; then
686       if ! [ -r /var/run/dbus/pid ] ; then
687         einfo "Starting acpi daemon."
688         /etc/init.d/acpid start >>$DEBUG ; eend $?
689       else
690         eerror "acpid error: it seems you are running d-bus/hal, but acpid needs to be started before d-bus."
691         eerror "Solution: please activate acpid via /etc/runlevel.conf"
692         eend 1
693       fi
694     else
695       ewarn "acpi daemon already running."
696       eend 0
697     fi
698     eoutdent
699   fi
700 else
701 # APM
702   if checkbootparam "noapm"; then
703     ewarn "Skipping APM Bios detection as requested on boot commandline." ; eend 0
704   else
705     modprobe apm power_off=1 >>$DEBUG 2>&1
706     if [ "$?" = "0" ] ; then
707        if [ -x /etc/init.d/apmd ] ;then
708           einfo "APM Bios found, enabling power management functions."
709           /etc/init.d/apmd start ; eend $?
710        fi
711     else
712       eerror "Loading apm module failed." ; eend 1
713     fi
714   fi
715 fi
716 }
717 # }}}
718
719 # {{{ PCMCIA Check/Setup
720 # This needs to be done before other modules are being loaded (by hwsetup)
721 config_pcmcia(){
722 if checkbootparam "nopcmcia"; then
723   ewarn "Skipping PCMCIA detection as requested on boot commandline." ; eend 0
724 else
725   if /usr/sbin/laptop-detect ; then
726     einfo "Detected Laptop - checking for PCMCIA." && eend 0
727     modprobe pcmcia_core >>$DEBUG 2>&1
728     # Try Cardbus or normal PCMCIA socket drivers
729     modprobe yenta_socket >>$DEBUG 2>&1 || modprobe i82365 >>$DEBUG 2>&1 || modprobe pd6729 >>$DEBUG 2>&1 || modprobe tcic >>$DEBUG 2>&1
730     if [ "$?" = "0" ]; then
731       modprobe ds >>$DEBUG 2>&1
732       if [ -d /proc/bus/pccard ] ; then
733        if [ -x /sbin/cardmgr ] ; then
734         einfo "PCMCIA found, starting cardmgr."
735         cardmgr >>$DEBUG 2>&1 && sleep 6 && eend 0
736        else
737         eerror "No cardmgr found. Make sure package pcmciautils is installed, it should handle it instead." ; eend 1
738        fi
739       fi
740     fi
741   fi
742 fi
743 }
744 # }}}
745
746 # {{{ run software synthesizer via speakup
747 config_swspeak(){
748 if checkbootparam swspeak ; then
749  if [ -d /proc/speakup/ ] ; then
750   einfo "Bootoption swspeak found. Kernel supports speakup." ; eend 0
751   eindent
752    if [ -x /etc/init.d/speech-dispatcher ] ; then
753      einfo "Starting speech-dispatcher."
754      /etc/init.d/speech-dispatcher start 1>>DEBUG ; eend $?
755      einfo "Activating sftsyn in Kernel."
756      echo sftsyn >/proc/speakup/synth_name ; eend $?
757      einfo "Just run swspeak if you want to use software synthesizer via speakup."
758      flite -o play -t "Finished activating software speakup. Just run swspeak when booting finished."
759    else
760     eerror "speech-dispatcher not available. swspeak will not work without it." ; eend 1
761     flite -o play -t "speech-dispatcher not available. speakup will not work without it."
762    fi
763   eoutdent
764  else
765   eerror "Kernel does not seem to support speakup. Skipping swspeak." ; eend 1
766   flite -o play -t "Kernel does not seem to support speakup. Sorry."
767  fi
768 fi
769 }
770 # }}}
771
772 # {{{ Check for blind option or brltty
773 config_blind(){
774 BLIND=""
775 checkbootparam "blind" && BLIND="yes"
776 BRLTTY="$(getbootparam brltty 2>>$DEBUG)"
777
778 if [ -n "$BLIND" -o -n "$BRLTTY" ]; then
779   if [ -x /sbin/brltty ]; then
780     # Blind option detected, start brltty now.
781     # modprobe serial_core parport_serial generic_serial && echo "done"
782     CMD=brltty
783     BRLTYPE=""
784     BRLDEV=""
785     BRLTEXT=""
786     if [ -n "$BRLTTY" ]; then
787       # Extra options
788       BRLTYPE="${BRLTTY%%,*}"
789       R="${BRLTTY#*,}"
790       if [ -n "$R" -a "$R" != "$BRLTTY" ]; then
791         BRLTTY="$R"
792         BRLDEV="${BRLTTY%%,*}"
793         R="${BRLTTY#*,}"
794         if [ -n "$R" -a "$R" != "$BRLTTY" ]; then
795           BRLTTY="$R"
796           BRLTEXT="${BRLTTY%%,*}"
797           R="${BRLTTY#*,}"
798         fi
799       fi
800     fi
801     [ -n "$BRLTYPE" ] && CMD="$CMD -b $BRLTYPE"
802     [ -n "$BRLDEV"  ] && CMD="$CMD -d $BRLDEV"
803     [ -n "$BRLTEXT" ] && CMD="$CMD -t $BRLTEXT"
804     einfo "Starting braille-display manager."
805 #    ( exec $CMD & )
806     ( sh -c "$CMD" & )
807     sleep 2 && BLINDSOUND="yes"
808     eend 0
809   fi
810 fi
811 }
812 # }}}
813
814 # {{{ Interactive configuration
815 config_interactive(){
816 if [ -n "$INTERACTIVE" ] ; then
817 einfo "Entering interactive configuration second stage."
818
819   echo " ${GREEN}Your console keyboard defaults to: ${MAGENTA}${KEYTABLE}"
820   echo -n "${CYAN}Do you want to (re)configure your console keyboard?${NORMAL} [Y/n] "
821   read a
822   [ "$a" != "n" ] && /usr/sbin/dpkg-reconfigure console-data ; eend $?
823
824   echo -n "${CYAN}Do you want to (re)configure your soundcard?${NORMAL} [Y/n] "
825   read a
826   [ "$a" != "n" ] && alsaconf && ( exec aumix -m 0 >>$DEBUG 2>&1 & ) ; eend $?
827
828   echo -n "${CYAN}Do you want to (re)configure your graphics (X11) subsystem?${NORMAL} [Y/n] "
829   read a
830   [ "$a" != "n" ] && xorgcfg -textmode ; eend $?
831   echo " ${GREEN}Interactive configuration finished. Everything else should be fine for now.${NORMAL}"
832 fi
833 eend 0
834 }
835 # }}}
836
837 # {{{ AGP
838 config_agp(){
839 if checkbootparam forceagp ; then
840 # Probe for AGP. Hope this can fail safely
841   stringinfile "AGP" "/proc/pci" 2>>$DEBUG && { modprobe agpgart || modprobe agpgart agp_try_unsupported=1; } >>$DEBUG 2>&1 && einfo "AGP bridge detected." ; eend 0
842 fi
843 }
844 # }}}
845
846 # {{{ automount(er)
847 config_automounter(){
848 if checkbootparam automounter ; then
849   RUNLEVEL="$(runlevel)"
850   AUTOMOUNTER=""
851   [ -x /etc/init.d/autofs ] && [ "$RUNLEVEL" != "N 1" ] && [ "$RUNLEVEL" != "N S" ] && AUTOMOUNTER="yes"
852
853 addautomount(){
854 # /dev/ice  options
855   d="${1##*/}"
856   if [ -n "$AUTOMOUNTER" ]; then
857     [ -d "/mnt/$d" -a ! -L "/mnt/$d" ] && rmdir /mnt/$d
858     [ -d "/mnt/auto/$d" ] || mkdir -p "/mnt/auto/$d"
859     [ -L "/mnt/$d" ]      || ln -s "/mnt/auto/$d" "/mnt/$d"
860     anew="$d        -fstype=auto,$2 :$i"
861     stringinfile "$anew" "/etc/auto.mnt" || echo "$anew" >> /etc/auto.mnt
862     AUTOMOUNTS="$AUTOMOUNTS $d"
863     new="$1 /mnt/auto/$d  auto   users,noauto,exec,$2 0 0"
864   else
865     [ -d /mnt/$d ] && mkdir -p /mnt/$d
866     new="$1 /mnt/$d  auto   users,noauto,exec,$2 0 0"
867   fi
868   stringinfile "$new" "/etc/fstab" || echo "$new" >> /etc/fstab
869 }
870
871   AUTOMOUNTS="floppy cdrom"
872 # Add new devices to /etc/fstab and /etc/auto.mnt
873   for i in /dev/cdrom?*; do
874     if [ -L $i ]; then
875       addautomount "$i" "ro"
876     fi
877   done
878 fi
879
880 if [ -n "$AUTOMOUNTER" ]; then
881 # Check for floppy dir, reinstall with automounter
882   [ -d /mnt/floppy -a ! -L /mnt/floppy ] && rmdir /mnt/floppy
883   [ -d /mnt/auto/floppy ] || mkdir -p /mnt/auto/floppy
884   [ -L /mnt/floppy ] || ln -s /mnt/auto/floppy /mnt/floppy
885   [ -d /mnt/cdrom -a ! -L /mnt/cdrom ] && rmdir /mnt/cdrom
886   [ -d /mnt/auto/cdrom ] || mkdir -p /mnt/auto/cdrom
887   [ -L /mnt/cdrom ] || ln -s /mnt/auto/cdrom /mnt/cdrom
888   rm -f /etc/fstab.new
889 # Replace paths from bootfloppy
890   sed 's|/mnt/cdrom|/mnt/auto/cdrom|g;s|/mnt/floppy|/mnt/auto/floppy|g' /etc/fstab > /etc/fstab.new
891   mv -f /etc/fstab.new /etc/fstab
892 # Start automounter now
893   einfo "Starting automounter for ${AUTOMOUNTS}."
894   /etc/init.d/autofs start >>$DEBUG ; eend $?
895 fi
896 }
897 # }}}
898
899 # {{{ Collect partitions from /proc/partitions first for enabling DMA
900 check_partitions(){
901 partitions=""
902 IDEDISKS=""
903 while read major minor blocks partition relax; do
904   partition="${partition##*/}"
905   [ -z "$partition" -o ! -e "/dev/$partition" ] && continue
906   case "$partition" in
907     hd?) IDEDISKS="$IDEDISKS $partition";;                # IDE  Harddisk, entire disk
908     sd?) ;;                                               # SCSI Harddisk, entire disk
909 #    [hs]d*) partitions="$partitions /dev/$partition";;    # IDE or SCSI disk partition
910     [hs]d*|ub*) partitions="$partitions /dev/$partition";;    # IDE, USB or SCSI disk partition
911   esac
912 done <<EOT
913 $(awk 'BEGIN{old="__start"}{if($0==old){exit}else{old=$0;if($4&&$4!="name"){print $0}}}' /proc/partitions)
914 EOT
915 }
916 check_partitions 1>/dev/null 2>&1 # avoid output "check_partitions:3: read-only file system"
917 # }}}
918
919 # {{{ Enable DMA for all IDE drives now if not disabled
920 # Notice: Already done by linuxrc, but make sure it's done also on harddisk-installed systems
921 config_dma(){
922 if checkbootparam "nodma"; then
923   ewarn "Skipping DMA accelleration as requested on boot commandline." ; eend 0
924 else
925   for d in $(cd /proc/ide 2>>$DEBUG && echo hd[a-z]); do
926     if test -d /proc/ide/$d; then
927       if egrep -q 'using_dma[ \t]+0' /proc/ide/$d/settings 2>>$DEBUG; then
928         MODEL="$(cat /proc/ide/$d/model 2>>$DEBUG)"
929         test -z "$MODEL" && MODEL="[GENERIC IDE DEVICE]"
930         einfo "Enabling DMA acceleration for: ${WHITE}$d        ${YELLOW}[${MODEL}]${NORMAL}"
931         echo "using_dma:1" >/proc/ide/$d/settings
932         eend 0
933       fi
934     fi
935   done
936 fi
937 }
938 # }}}
939
940 # {{{ Start creating /etc/fstab with HD partitions and USB SCSI devices now
941 config_fstab(){
942
943 NOSWAP="yes" # we do not use swap by default!
944 if checkbootparam "swap" -o checkbootparam "anyswap" ; then
945    NOSWAP=''
946 fi
947
948 if checkbootparam "nofstab" -o checkbootparam "forensic" ; then
949   ewarn "Skipping /etc/fstab creation as requested on boot commandline." ; eend 0
950 else
951   checkbootparam "anyswap" && export ANYSWAP='yes' || export ANYSWAP=""
952   einfo "Scanning for harddisk partitions and creating /etc/fstab. (Disable this via boot option: nofstab)"
953   iszsh && setopt nonomatch
954   if [ -x /usr/sbin/rebuildfstab ] ; then
955     config_userfstab || fstabuser=grml
956     /usr/sbin/rebuildfstab -r -u $fstabuser -g $fstabuser ; eend $?
957   else
958     ewarn "Command rebuildfstab not found. Install package grml-rebuildfstab." ; eend 1
959   fi
960   if [ -e /var/run/rebuildfstab.pid ]; then
961     # Another instance of rebuildfstab, probably from hotplug, is still running, so just wait.
962     sleep 8
963   fi
964 fi
965 # Scan for swap, config, homedir
966 if [ -z "$NOSWAP" ]; then
967    einfo "Searching for swap partition(s) as requested."
968 fi
969 GRML_IMG=""
970 GRML_SWP=""
971 HOMEDIR="$(getbootparam home)"
972 if [ -n "$partitions" ]; then
973  while read p m f relax; do
974   case "$p" in *fd0*|*proc*|*sys*|*\#*) continue;; esac
975   partoptions="users,exec"
976   fnew=""
977   case "$f" in swap)
978    eindent
979    if [ -n "$NOSWAP" ]; then
980       if [ -z "$INSTALLED" ] ; then
981          ewarn "Ignoring swap partition ${WHITE}$p${NORMAL}. (Force usage via boot option 'swap', or execute grml-swapon)" ; eend 0
982       fi
983    else
984      case "$(dd if=$p bs=1 count=6 skip=4086 2>/dev/null)" in
985              S1SUSP|S2SUSP|pmdisk|[zZ]*)
986                 if [ -n "$ANYSWAP" ] ; then
987                   einfo "Using swap partition ${WHITE}${p}${NORMAL} [bootoption anyswap found]."
988                   swapon $p 2>>$DEBUG ; eend $?
989                 else
990                   ewarn "Suspend signature on ${WHITE}${p}${NORMAL} found, not using as swap. (Force usage via boot option: anyswap)"
991                 fi
992                ;;
993              *)
994                 if [[ "$p" == LABEL* ]] ; then
995                    p=$(blkid -t $p | awk -F: '{print $1}')
996                 fi
997                 if grep -q $p /proc/swaps ; then
998                    ewarn "Not using swap partition ${WHITE}${p}${NORMAL} as it is already in use." ; eend 0
999                 else
1000                    einfo "Using swap partition ${WHITE}${p}${NORMAL}."
1001                    swapon $p 2>>$DEBUG ; eend $?
1002                 fi
1003                ;;
1004      esac
1005    fi
1006    eoutdent
1007    continue
1008    ;;
1009   esac
1010 # Create mountdir if not already present, but don't try to create stuff like /proc/bus/usb
1011 # Notice: grml-rebuildfstab >= 0.3-1 handles this now
1012 #  case "$m" in *none*|*proc*|*sys*|'') continue ;; esac
1013 #  [ -d "$m" ] || mkdir -p "$m"
1014 # WARNING: NTFS RW mounts are only safe since Kernel 2.6.11
1015   [ "$f" = "ntfs" -a "${KERNEL%.*}" != "2.6" ] && continue
1016   MOUNTOPTS="ro"
1017   case "$f" in
1018     vfat|msdos|ntfs) MOUNTOPTS="$MOUNTOPTS,uid=${fstabuser},gid=${fstabuser}" ;;
1019     ext2|ext3|reiserfs|jfs|reiser4|xfs) MOUNTOPTS="$MOUNTOPTS,noatime" ;;
1020     *) continue ;;
1021     # *) NONEFOUND='1'; continue ;;
1022   esac
1023   mount -o "$MOUNTOPTS" -t $f $p $m 2>>$DEBUG || continue
1024   # Activate swapfile, if exists
1025   SWAPFILE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ss][Ww][Pp] 2>/dev/null)"
1026   if [ -z "$NOSWAP" -a -n "$SWAPFILE" -a -f "$SWAPFILE" ]; then
1027    mount -o remount,rw $m
1028    if swapon "$SWAPFILE" 2>>$DEBUG ; then
1029     einfo "Using GRML swapfile ${SWAPFILE}."
1030     fnew="$SWAPFILE swap swap defaults 0 0"
1031     stringinfile "$fnew" "/etc/fstab" || echo "$fnew" >> /etc/fstab
1032     GRML_SWP="$GRML_SWP $SWAPFILE"
1033     eend 0
1034    fi
1035    mount -o remount,ro $m 2>>$DEBUG
1036   fi
1037   IMAGE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ii][Mm][Gg] 2>/dev/null)"
1038   if [ -z "$INSTALLED" -a -z "$GRML_IMG" -a -n "$IMAGE" -a -f "$IMAGE" ]; then
1039    if [ -n "$HOMEDIR" ]; then
1040     if [ "$HOMEDIR" != "scan" -a "$HOMEDIR" != "$IMAGE" -a "$HOMEDIR" != "${IMAGE%/*.*}" ]; then
1041      continue
1042     fi
1043    fi
1044    if type -a grml-image >/dev/null 2>&1 && grml-image "$IMAGE" </dev/console >/dev/console 2>&1; then
1045     GRML_IMG="$IMAGE"
1046     mount -o remount,ro $m 2>>$DEBUG
1047    fi
1048   fi
1049   eend 0
1050   # Umount, if not in use
1051   umount -r $m 2>/dev/null
1052  done <<EOT
1053 $(cat /etc/fstab)
1054 EOT
1055 fi
1056 }
1057 # }}}
1058
1059 # {{{ Mouse
1060 config_mouse(){
1061 if [ -n "$MOUSE_DEVICE" ] ; then
1062   einfo "Detecting mouse: ${MOUSE_FULLNAME} at ${MOUSE_DEVICE}" ; eend $?
1063 fi
1064 }
1065 # }}}
1066
1067 # {{{ IPv6 configuration
1068 # Load IPv6 kernel module and print IP adresses
1069 config_ipv6(){
1070 if checkbootparam "ipv6"; then
1071   einfo "Enabling IPv6 as requested on boot commandline (sleeping for 2 seconds)"
1072   modprobe ipv6
1073   # we probably need some time until stateless autoconfiguration has happened
1074   sleep 2
1075   NETDEVICES="$(awk -F: '/eth.:|tr.:|wlan.:/{print $1}' /proc/net/dev 2>>$DEBUG)"
1076   for DEVICE in `echo "$NETDEVICES"`
1077   do
1078     eindent
1079     einfo "$DEVICE:"
1080     ADDRESSES="$(ifconfig $DEVICE | awk '/.*inet6 addr:.*/{print $3}')"
1081     COUNT="$(ifconfig $DEVICE | awk '/.*inet6 addr:.*/{ sum += 1};END {print sum }')"
1082     eindent
1083     for ADDR in `echo "$ADDRESSES"`
1084     do
1085       einfo "$ADDR"
1086     done
1087     if [ "$COUNT" -eq "0" ]
1088     then
1089       einfo "(none)" ; eend 1
1090     fi
1091     eoutdent
1092     eoutdent
1093   done
1094   eend 0
1095 fi
1096 }
1097 # }}}
1098
1099 # {{{ Fat-Client-Version: DHCP Broadcast for IP address
1100 config_dhcp(){
1101 if checkbootparam "nodhcp"; then
1102   ewarn "Skipping DHCP broadcast/network detection as requested on boot commandline." ; eend 0
1103 else
1104   NETDEVICES="$(awk -F: '/eth.:|tr.:|wlan.:/{print $1}' /proc/net/dev 2>>$DEBUG)"
1105   rm -rf /etc/network/status ; mkdir -p /etc/network/status
1106   for DEVICE in `echo "$NETDEVICES"` ; do
1107     einfo "Network device ${WHITE}${DEVICE}${NORMAL} detected, DHCP broadcasting for IP. (Backgrounding)"
1108     trap 2 3 11
1109     ifconfig $DEVICE up >>$DEBUG 2>&1
1110     ( pump -i $DEVICE >>$DEBUG 2>&1 && echo finished_running_pump > /etc/network/status/$DEVICE ) &
1111     trap "" 2 3 11
1112     sleep 1
1113     eend 0
1114   done
1115 fi
1116 }
1117 # }}}
1118
1119 # {{{ helper functions
1120 findfile(){
1121 FOUND=""
1122 # search all partitions for a file in the root directory
1123 for i in /mnt/[sh]d[a-z] /mnt/[sh]d[a-z][1-9] /mnt/[sh]d[a-z][1-9]?*; do
1124 # See if it's already mounted
1125   [ -f "$i/$1" ] &&  { echo "$i/$1"; return 0; }
1126   if [ -d "$i" ] && mount -r "$i" 2>>$DEBUG; then
1127     [ -f "$i/$1" ] && FOUND="$i/$1"
1128     umount -l "$i" 2>>$DEBUG
1129     [ -n "$FOUND" ] && { echo "$FOUND"; return 0; }
1130   fi
1131 done
1132 return 2
1133 }
1134
1135 fstype(){
1136 case "$(file -s $1)" in
1137   *[Ff][Aa][Tt]*|*[Xx]86*) echo "vfat"; return 0;;
1138   *[Rr][Ee][Ii][Ss][Ee][Rr]*)  echo "reiserfs"; return 0;;
1139   *[Xx][Ff][Ss]*)  echo "xfs"; return 0;;
1140   *[Ee][Xx][Tt]3*) echo "ext3"; return 0;;
1141   *[Ee][Xx][Tt]2*) echo "ext2"; return 0;;
1142   *data*)          echo "invalid"; return 0;;
1143   *) echo "auto"; return 0;;
1144 esac
1145 }
1146
1147 # Try to mount this filesystem read-only, without or with encryption
1148 trymount(){
1149 # Check if already mounted
1150 case "$(cat /proc/mounts)" in *\ $2\ *) return 0;; esac
1151 # Apparently, mount-aes DOES autodetect AES loopback files.
1152 [ -b "$1" ] && { mount -t auto -o ro "$1" "$2" 2>>$DEBUG; RC="$?"; }
1153 # We need to mount crypto-loop files with initial rw support
1154 [ -f "$1" ] && { mount -t auto -o loop,rw "$1" "$2" 2>>$DEBUG; RC="$?"; }
1155 # Mount succeeded?
1156 [ "$RC" = "0" ] && return 0
1157 echo ""
1158 einfo "Filesystem not autodetected, trying to mount $1 with AES256 encryption."
1159 a="y"
1160 while [ "$a" != "n" -a "$a" != "N" ]; do
1161 # We need to mount crypto-loop files with initial rw support
1162  mount -t auto -o loop,rw,encryption=AES256 "$1" "$2" && return 0
1163  echo -n "${RED}Mount failed, retry? [Y/n] ${NORMAL}"
1164  # Problem with ioctl() from getpasswd()?
1165  # read a
1166  read a
1167 done
1168 return 1
1169 }
1170 # }}}
1171
1172 # {{{ CPU-detection
1173 config_cpu(){
1174 if checkbootparam "nocpu"; then
1175   ewarn "Skipping CPU detection as requested on boot commandline." ; eend 0
1176 else
1177   if ! [ -x /etc/init.d/powernowd ] ; then
1178     ewarn "Skipping CPU detection as powernowd dependencies are not fulfilled." ; eend 1
1179   elif [ ! -e /lib/modules/${KERNEL}/kernel/arch/i386/kernel/cpu/cpufreq -o ! -e /lib/modules/${KERNEL}/kernel/drivers/cpufreq ] ; then
1180     ewarn "Skipping CPU detection as module dependencies are not fulfilled." ; eend 1
1181   else
1182     if [[ `grep -c processor /proc/cpuinfo` -gt 1 ]] ; then
1183       einfo "Detecting CPU:"
1184       CPU=$(awk -F: '/^processor/{printf "      Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG)
1185       echo $CPU | sed 's/ \{1,\}/ /g'
1186       eend 0
1187     else
1188       einfo "Detecting CPU: `awk -F: '/^processor/{printf " Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG` " ; eend 0
1189     fi
1190     if /usr/sbin/laptop-detect ; then
1191     einfo "Detected Laptop - trying to use cpu frequency scaling:"
1192 #      loadcpumod() {
1193 #      for module in /lib/modules/${KERNEL}/kernel/arch/i386/kernel/cpu/cpufreq/*.ko /lib/modules/${KERNEL}/kernel/drivers/cpufreq/*.ko ; do
1194 #    # modprobe ${${${${(f)"$(_call_program modules ${(M)words[1]##*/}modprobe -l | grep cpufreq 2>>$DEBUG)"}:#}##*/}%.*}
1195 #        modprobe `basename ${module%%\.ko}` 1>>$DEBUG 2>&1
1196 #      done
1197 #      }
1198 #    CPU=$(grep 'model name' /proc/cpuinfo | cut -b14- | head -1)
1199 #    eindent
1200 #    if [[ $CPU = *Intel* ]] ; then
1201 #      einfo "Detected CPU is of type Intel - loading modules and starting cpudyn."
1202 #      local DETECTED=1
1203 #      loadcpumod
1204 #      /etc/init.d/cpudyn start 1>>$DEBUG ; eend $?
1205 #    fi
1206 #    if [[ $CPU = *AMD* ]] ; then
1207 #      einfo "Detected CPU is of type AMD - loading modules and starting powernowd."
1208 #      local DETECTED=1
1209 #      loadcpumod
1210 #      /etc/init.d/powernowd start 1>>$DEBUG ; eend $?
1211 #    fi
1212
1213      eindent
1214      if [ -r /usr/bin/cpufreq-detect.sh ] ; then
1215        . /usr/bin/cpufreq-detect.sh
1216        if [ -n "$MODULE" -a "$MODULE" != none ]; then
1217          einfo "Loading module ${MODULE} and starting powernowd."
1218          modprobe cpufreq_userspace 1>>$DEBUG
1219          modprobe "$MODULE" 1>>$DEBUG || modprobe "$MODULE_FALLBACK" 1>>$DEBUG
1220          /etc/init.d/powernowd start 1>>$DEBUG ; eend $?
1221        else
1222          ewarn "Could not detect an appropriate CPU for use with powernowd - skipping." && eend 1
1223        fi
1224      fi
1225      eoutdent
1226    fi
1227   fi
1228 fi
1229 }
1230 # }}}
1231
1232 # {{{ autostart of ssh
1233 config_ssh(){
1234 if checkbootparam ssh ; then
1235   SSH_PASSWD="$(getbootparam 'ssh' 2>>$DEBUG)"
1236   einfo "Bootoption passwd found."
1237   if [ -n "$SSH_PASSWD" ] ; then
1238     echo "grml:$SSH_PASSWD" | chpasswd -m
1239     einfo "Starting secure shell server in background."
1240     /etc/init.d/rmnologin start 1>>$DEBUG 2>>$DEBUG
1241     /etc/init.d/ssh start 1>>$DEBUG 2>>$DEBUG &
1242     eend 0
1243   else
1244     eerror "No given password for ssh found. Autostart of SSH will not work." ; eend 1
1245   fi
1246   eindent
1247     ewarn "Warning: please change the password for user grml set via bootparameter as soon as possible!"
1248   eoutdent
1249 fi
1250 }
1251 # }}}
1252
1253 # {{{ set password for user grml
1254 config_passwd(){
1255 if checkbootparam passwd >>$DEBUG 2>&1; then
1256   einfo "Bootoption passwd found."
1257   PASSWD="$(getbootparam 'passwd' 2>>$DEBUG)"
1258   if [ -n "$PASSWD" ] ; then
1259     echo "grml:$PASSWD" | chpasswd -m ; eend $?
1260   else
1261     eerror "No given password for ssh found. Autostart of SSH will not work." ; eend 1
1262   fi
1263   eindent
1264     ewarn "Warning: please change the password for user grml set via bootparameter as soon as possible!"
1265   eoutdent
1266 fi
1267 }
1268 # }}}
1269
1270 # {{{ Check for persistent homedir option and eventually mount /home from there, or use a loopback file.
1271 config_homedir(){
1272 HOMEDIR="$(getbootparam home)"
1273 MYHOMEDEVICE=""
1274 MYHOMEMOUNTPOINT=""
1275 MYHOMEDIR=""
1276 if [ -n "$HOMEDIR" ]; then
1277   einfo "Bootoption home detected." && eend 0
1278   case "$HOMEDIR" in
1279     /dev/*)
1280     MYHOMEDEVICE="${HOMEDIR##/dev/}"
1281     MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
1282     MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
1283     MYHOMEDIR="/mnt/${HOMEDIR##/dev/}"
1284   ;;
1285     /mnt/*)
1286     MYHOMEDEVICE="${HOMEDIR##/mnt/}"
1287     MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
1288     MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
1289     MYHOMEDIR="$HOMEDIR"
1290   ;;
1291     [Aa][Uu][Tt][Oo]|[Ss][Cc][Aa][Nn]|[Ff][Ii][Nn][Dd])
1292     MYHOMEDIR="$(findfile grml.img)"
1293     MYHOMEDEVICE="${MYHOMEDIR##/mnt/}"
1294     MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
1295     MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
1296   ;;
1297   *)
1298     eerror "Invalid home= option '$HOMEDIR' specified (must start with /dev/ or /mnt/ or 'scan')." ; eend 1
1299     eerror "Option ignored." ; eend 1
1300   ;;
1301   esac
1302 fi
1303
1304 if [ -n "$MYHOMEDIR" ]; then
1305   if trymount "$MYHOMEDEVICE" "$MYHOMEMOUNTPOINT"; then
1306     [ -f "$MYHOMEMOUNTPOINT/grml.img" ] && MYHOMEDIR="$MYHOMEMOUNTPOINT/grml.img"
1307     while read device mountpoint fs relax; do
1308       case "$mountpoint" in *$MYHOMEMOUNTPOINT*)
1309         case "$fs" in *[Nn][Tt][Ff][Ss]*)
1310           umount "$MYHOMEMOUNTPOINT"; eerror "Error: will not mount NTFS filesystem on $MYHOMEDEVICE read/write!" ; eend 1
1311           break
1312         ;;
1313         *[Ff][Aa][Tt]*)
1314         # Note: This currently won't work with encrypted partitions
1315         umount "$MYHOMEMOUNTPOINT"; mount -t vfat -o rw,uid=grml,gid=grml,umask=002 "$MYHOMEDEVICE" "$MYHOMEMOUNTPOINT"
1316         if [ ! -f "$MYHOMEDIR" ]; then
1317           ewarn "WARNING: FAT32 is not a good filesystem option for /home/grml (missing socket/symlink support)."
1318           ewarn "WARNING: Better use an ext2 loopback file on this device, and boot with home=$MYHOMEDEVICE/grml.img."
1319         fi
1320         ;;
1321       esac
1322       if mount -o remount,rw "$MYHOMEMOUNTPOINT"; then
1323         einfo "Mounting ${WHITE}$MYHOMEDIR${NORMAL} as ${WHITE}/home/grml${NORMAL}."
1324         if [ -f "$MYHOMEDIR" ]; then
1325           # It's a loopback file, mount it over the /home/grml directory
1326           trymount "$MYHOMEDIR" /home/grml
1327           RC="$?"
1328           [ "$RC" = "0" ] && ERROR="$(mount -o remount,rw /home/grml 2>&1)"
1329           RC="$?"
1330         else
1331           # Do a --bind mount
1332           ERROR="$(mount --bind "$MYHOMEDIR" /home/grml 2>&1)"
1333           RC="$?"
1334         fi
1335         [ "$RC" = "0" ] && eend 0 || ( eerror "${ERROR}" ; eend 1 )
1336       fi
1337       break
1338       ;;
1339     esac
1340   done <<EOT
1341 $(cat /proc/mounts)
1342 EOT
1343   fi
1344 fi
1345 }
1346 # }}}
1347
1348 # {{{ Check for scripts on CD-ROM
1349 config_cdrom_scripts(){
1350 if checkbootparam "script"; then
1351   for script in /cdrom/scripts/* ; do
1352     einfo " grml script found on CD, executing ${WHITE}${script}${NORMAL}."
1353     . $script
1354   done
1355 fi
1356 }
1357 # }}}
1358
1359 # {{{ Sound
1360 config_mixer(){
1361 if ! [ -x /usr/bin/aumix ] ; then
1362   eerror "aumix binary not available. Can not set sound volumes therefore." ; eend 1
1363 else
1364
1365   if checkbootparam vol ; then
1366     VOL="$(getbootparam 'vol' 2>>$DEBUG)"
1367     if [ -z "$VOL" ] ; then
1368       eerror "Bootoption vol found but no volume level/parameter given. Using defaults." ; eend 1
1369       VOL='75' # default
1370     fi
1371   else
1372     VOL='75' # default
1373   fi
1374
1375   if checkbootparam nosound ; then
1376     einfo "Muting sound devices on request."
1377     # some IBM notebooks require the following stuff:
1378     if [ -x /usr/bin/amixer ] ; then
1379        if amixer get Front 1>/dev/null 2>>$DEBUG ; then
1380           amixer set Front unmute 1>/dev/null
1381           amixer set Front 0% 1>/dev/null
1382        fi
1383     fi
1384     ERROR=$(aumix -w 0 -v 0 -p 0 -m 0 2>&1) ; RC=$?
1385     if [ -n "$ERROR" ] ; then
1386        eindent
1387        eerror "Problem muting sound devices: $ERROR"
1388        eoutdent
1389     fi
1390     eend $RC
1391   elif [ -z "$INSTALLED" ]; then
1392       einfo "Setting mixer volumes to level ${WHITE}${VOL}${NORMAL}."
1393       # some IBM notebooks require the following stuff:
1394       if [ -x /usr/bin/amixer ] ; then
1395          if amixer get Front 1>/dev/null 2>>$DEBUG ; then
1396             amixer set Front unmute 1>/dev/null
1397             amixer set Front ${VOL}% 1>/dev/null
1398          fi
1399       fi
1400       ERROR=$(aumix -w $VOL -v $VOL -p $VOL -m $VOL 2>&1) ; RC=$?
1401       if [ -n "$ERROR" ] ; then
1402          eindent
1403          eerror "Problem setting mixer volumes: $ERROR"
1404          eoutdent
1405       fi
1406       eend $RC
1407   fi
1408
1409 fi
1410 }
1411 # }}}
1412
1413 # {{{ modem detection
1414 config_modem(){
1415 if checkbootparam "nomodem"; then
1416   ewarn "Skipping check for AC97 modem controller as requested on boot commandline." ; eend 0
1417 else
1418   if [ -x /etc/init.d/sl-modem-daemon ] ; then
1419    if lspci | grep Intel | grep -q "AC'97 Modem Controller" ; then
1420      einfo "AC97 modem controller detected. Starting sl-modem-daemon in background."
1421      /etc/init.d/sl-modem-daemon start >>$DEBUG &
1422      eend 0
1423    fi
1424   fi
1425 fi
1426 }
1427 # }}}
1428
1429 # {{{ keyboard add-ons
1430 config_setkeycodes(){
1431 if checkbootparam "setkeycodes" ; then
1432  einfo "Setting keycodes as requested via bootparameter 'setkeycodes'."
1433   # MS MM keyboard add-on
1434   # fix
1435   setkeycodes e001 126 &>/dev/null
1436   setkeycodes e059 127 &>/dev/null
1437   # fn keys
1438   setkeycodes e03b 59 &>/dev/null
1439   setkeycodes e008 60 &>/dev/null
1440   setkeycodes e007 61 &>/dev/null
1441   setkeycodes e03e 62 &>/dev/null
1442   setkeycodes e03f 63 &>/dev/null
1443   setkeycodes e040 64 &>/dev/null
1444   setkeycodes e041 65 &>/dev/null
1445   setkeycodes e042 66 &>/dev/null
1446   setkeycodes e043 67 &>/dev/null
1447   setkeycodes e023 68 &>/dev/null
1448   setkeycodes e057 87 &>/dev/null
1449   setkeycodes e058 88 &>/dev/null
1450   # hp keycodes
1451   setkeycodes e00a 89 e008 90 &>/dev/null
1452  eend 0
1453 fi
1454 }
1455 # }}}
1456
1457 # {{{ wondershaper
1458 config_wondershaper(){
1459  if checkbootparam "wondershaper" ; then
1460     WONDER="$(getbootparam wondershaper 2>>$DEBUG)"
1461     CMD=wondershaper
1462     DEVICE=""
1463     DOWNSTREAM=""
1464     UPSTREAM=""
1465     if [ -n "$WONDER" ]; then
1466       # Extra options
1467       DEVICE="${WONDER%%,*}"
1468       R="${WONDER#*,}"
1469       if [ -n "$R" -a "$R" != "$WONDER" ]; then
1470         WONDER="$R"
1471         DOWNSTREAM="${WONDER%%,*}"
1472         R="${WONDER#*,}"
1473         if [ -n "$R" -a "$R" != "$WONDER" ]; then
1474           WONDER="$R"
1475           UPSTREAM="${WONDER%%,*}"
1476           R="${WONDER#*,}"
1477         fi
1478       fi
1479     fi
1480     [ -n "$DEVICE" ]     && CMD="$CMD $DEVICE"
1481     [ -n "$DOWNSTREAM" ] && CMD="$CMD $DOWNSTREAM"
1482     [ -n "$UPSTREAM" ]   && CMD="$CMD $UPSTREAM"
1483     einfo "Starting wondershaper (${CMD}) in background."
1484     ( sh -c $CMD & ) && eend 0
1485  fi
1486 }
1487 # }}}
1488
1489 # {{{ syslog-ng
1490 config_syslog(){
1491  if checkbootparam "nosyslog"; then
1492   ewarn "Not starting syslog-ng as requested on boot commandline." ; eend 0
1493  else
1494   einfo "Starting syslog-ng in background."
1495   /etc/init.d/syslog-ng start 1>>$DEBUG &
1496   eend 0
1497  fi
1498 }
1499 # }}}
1500
1501 # {{{ gpm
1502 config_gpm(){
1503  if checkbootparam "nogpm"; then
1504   ewarn "Not starting GPM as requested on boot commandline." ; eend 0
1505  else
1506   einfo "Starting gpm in background."
1507 #  /etc/init.d/gpm start 1>>$DEBUG &
1508   ( while [ ! -e /dev/psaux ]; do sleep 5; done; /etc/init.d/gpm start 1>>$DEBUG ) &
1509   eend 0
1510  fi
1511 }
1512 # }}}
1513
1514 # {{{ services
1515 config_services(){
1516  if checkbootparam "services" ; then
1517     SERVICE="$(getbootparam services 2>>$DEBUG)"
1518     SERVICELIST=$(echo "$SERVICE" | sed 's/,/\\n/g')
1519     SERVICENL=$(echo "$SERVICE" | sed 's/,/ /g')
1520     einfo "Starting service(s) ${SERVICENL} in background."
1521     for service in $(echo -e $SERVICELIST) ; do
1522        /etc/init.d/${service} start 1>>$DEBUG &
1523     done
1524     [ "$?" == "0" ] ; eend $?
1525  fi
1526 }
1527 # }}}
1528
1529 # {{{ config files
1530 config_netconfig(){
1531  if checkbootparam netconfig ; then
1532   CONFIG="$(getbootparam 'netconfig' 2>>$DEBUG)"
1533   CONFIGFILE='/tmp/netconfig.grml'
1534
1535   getconfig() {
1536   wget --timeout=10 --dns-timeout=10  --connect-timeout=10 \
1537        --read-timeout=10 $CONFIG -O $CONFIGFILE && return 0 || return 1
1538   }
1539   einfo "Trying to get ${WHITE}${CONFIG}${NORMAL}"
1540   counter=10
1541   while ! getconfig && [[ "$counter" != 0 ]] ; do
1542     echo -n "Sleeping for 5 seconds and trying to get config again... "
1543     counter=$(( counter-1 ))
1544     echo "$counter tries left" ; sleep 1
1545   done
1546   if [ -r "$CONFIGFILE" ] ; then
1547     einfo "Downloading was successfull." ; eend 0
1548     einfo "md5sum of ${WHITE}${CONFIG}${NORMAL}: "
1549     md5sum $CONFIGFILE ; eend 0
1550     cd / && einfo "Unpacking ${WHITE}${CONFIGFILE}${NORMAL}:" && /usr/bin/unp $CONFIGFILE $EXTRACTOPTIONS ; eend $?
1551   else
1552     einfo "Sorry, could not fetch $CONFIG" ; eend 1
1553   fi
1554  fi
1555 }
1556 # }}}
1557
1558 # {{{ blindsound
1559 config_blindsound(){
1560  if checkbootparam "blind" ; then
1561     beep
1562     flite -o play -t "welcome to the gremel system"
1563  fi
1564 }
1565 # }}}
1566
1567 # {{{ welcome sound
1568 config_welcome(){
1569  if checkbootparam welcome ; then
1570   flite -o play -t "welcome to the gremel system"
1571  fi
1572 }
1573 # }}}
1574
1575 # {{{ fix/workaround for unionfs
1576 fix_unionfs(){
1577   if [ -z "$INSTALLED" ]; then
1578    touch /var/cache/apt/*cache.bin
1579   fi
1580 }
1581 # }}}
1582
1583 # {{{ create all /mnt-directories
1584 create_mnt_dirs(){
1585   ewarn "create_mnt_dirs is deprecated as grml-rebuildfstab does all we need."
1586   ewarn "Please set CONFIG_CREATE_MNT_DIRS='no' in /etc/grml/autoconfig" ; eend 0
1587 }
1588 # }}}
1589
1590 # {{{ start X window system via grml-x
1591 config_x_startup(){
1592 if checkbootparam startx ; then
1593  if [ -x /usr/X11R6/bin/X ] ; then
1594   if [ -z "$INSTALLED" ] ; then
1595    WINDOWMANAGER="$(getbootparam 'startx' 2>>$DEBUG)"
1596    if [ -z "$WINDOWMANAGER" ] ; then
1597      einfo "No window manager specified. Taking ${WHITE}wm-ng${NORMAL} as default." && eend 0
1598      WINDOWMANAGER="wm-ng"
1599    else
1600      einfo "Window manager ${WHITE}${WINDOWMANAGER}${NORMAL} found as bootoption." && eend 0
1601    fi
1602    einfo "Changing to runlevel 5 for starting grml-x ${WINDOWMANAGER}. Just exit X windows system to get full featured consoles."
1603    config_userfstab || fstabuser='grml'
1604  cat>|/etc/init.d/xstartup<<EOF
1605 #!/bin/sh
1606 # su - $fstabuser -c 'grml-x "$WINDOWMANAGER"'
1607 sudo -u $fstabuser -i /usr/bin/grml-x $WINDOWMANAGER 1>>$DEBUG
1608 EOF
1609    chmod 755 /etc/init.d/xstartup
1610    sed -i 's/^allowed_users=.*/allowed_users=anybody/' /etc/X11/Xwrapper.config
1611    sed -i 's#^6.*#6:2345:respawn:/bin/zsh --login -c "/etc/init.d/xstartup ; /bin/zsh"#'   /etc/inittab
1612    /sbin/telinit q ; eend $?
1613   else
1614     eerror "We are not running from CD - startx will not work, skipping it.
1615      Please use something like xdm, gdm or kdm for starting X on a harddisk system!" ; eend 1
1616   fi
1617  else
1618    eerror "/usr/X11R6/bin/X is not present on this grml flavour.
1619    Boot parameter startx does not work therefore." ; eend 1
1620  fi
1621 fi
1622 }
1623 # }}}
1624
1625 # {{{ configuration framework
1626 config_extract(){
1627 if checkbootparam extract ; then
1628  EXTRACT="$(getbootparam 'extract' 2>>$DEBUG)"
1629  EXTRACTOPTIONS="-- -x $EXTRACT"
1630 fi
1631 }
1632
1633 config_automount(){
1634 if checkbootparam noautoconfig -o checkbootparam forensic ; then
1635   ewarn "Skipping running automount of device(s) labeled GRMLCFG as requested." ; eend 0
1636 else
1637  if [ -z "$INSTALLED" ] ; then
1638   einfo "Searching for device(s) labeled with GRMLCFG." ; eend 0
1639   eindent
1640   [ -d /mnt/grml ] || mkdir /mnt/grml
1641   umount /mnt/grml 1>>$DEBUG 2>&1 # make sure it is not mounted
1642 # We do need the following fix so floppy disk is available to blkid in any case :-/
1643   if [ -r /dev/fd0 ] ; then
1644      einfo "Floppy device detected. Trying to access floppy disk. (Disable this via boot option: noautoconfig)"
1645 #     dd if=/dev/fd0 of=/dev/null bs=512 count=1 1>>$DEBUG 2>&1
1646      if timeout 4 dd if=/dev/fd0 of=/dev/null bs=512 count=1 1>>$DEBUG 2>&1 ; then
1647         blkid /dev/fd0 1>>$DEBUG 2>&1
1648      fi
1649   fi
1650   DEVICE=$(blkid -t LABEL=GRMLCFG | head -1 | awk -F: '{print $1}')
1651   [ -n "$DEVICE" ] && mount -t auto -o ro $DEVICE /mnt/grml ; RC="$?"
1652   if [[ $RC == 0 ]]; then
1653     einfo "Mounting device $DEVICE labeled GRMLCFG succeeded." ; eend 0
1654
1655     CONFIG=''
1656     CONFIG="$(/bin/ls -1d /mnt/grml/[Cc][Oo][Nn][Ff][Ii][Gg].[Tt][Bb][Zz] 2>>$DEBUG)"
1657     if [ -n "$CONFIG" ]; then
1658       einfo "Found file ${WHITE}${CONFIG}${NORMAL} - trying to extract it."
1659       cd /
1660       unp $CONFIG $EXTRACTOPTIONS ; eend $?
1661     else
1662       ewarn "Sorry, could not find file config.tbz on device with label GRMLCFG." ; eend 1
1663     fi
1664
1665     SCRIPT=''
1666     SCRIPT="$(/bin/ls -1d /mnt/grml/[Gg][Rr][Mm][Ll].[Ss][Hh] 2>>$DEBUG)"
1667     if [ -n "$SCRIPT" ]; then
1668       einfo "Found script ${WHITE}${SCRIPT}${NORMAL} - trying to execute it."
1669       $SCRIPT ; eend $?
1670     fi
1671     grep -q '/mnt/grml' /proc/mounts && umount /mnt/grml
1672   else
1673     ewarn "No devices with label GRMLCFG found." ; eend 0
1674   fi
1675   eoutdent
1676  fi
1677 fi
1678 }
1679
1680 config_myconfig(){
1681
1682 if checkbootparam "config" ; then
1683   CONFIG="$(getbootparam 'config' 2>>$DEBUG)"
1684   [ -z "$CONFIG" ] && CONFIG='config.tbz'
1685   einfo "Bootoption config found. config is set to: $CONFIG"
1686   eindent
1687     einfo "Trying to extract configuration file ${CONFIG}:"
1688     cd / && unp /cdrom/config/$CONFIG $EXTRACTOPTIONS ; eend $?
1689   eoutdent
1690 fi
1691
1692 if checkbootparam myconfig ; then
1693  MOUNTDEVICE="$(getbootparam 'myconfig' 2>>$DEBUG)"
1694  if [ -n "$MOUNTDEVICE" ]; then
1695    if checkbootparam file ; then
1696     FILENAME="$(getbootparam 'file' 2>>$DEBUG)"
1697     [ -n "$FILENAME" ] || FILENAME='config.tbz'
1698    fi
1699    [ -d /mnt/grml ] || mkdir /mnt/grml
1700    umount /mnt/grml 1>>$DEBUG 2>&1 # make sure it is not mounted
1701    mount -o ro -t auto $MOUNTDEVICE /mnt/grml ; RC="$?"
1702     if [[ $RC == 0 ]]; then
1703       einfo "Successfully mounted $MOUNTDEVICE to /mnt/grml (readonly)." ; eend 0
1704       eindent
1705       CONFIG=''
1706       CONFIG="$(/bin/ls -1d /mnt/grml/[Cc][Oo][Nn][Ff][Ii][Gg].[Tt][Bb][Zz] 2>>$DEBUG)"
1707       if [ -n "$CONFIG" ]; then
1708         einfo "Found file ${WHITE}${CONFIG}${NORMAL} - trying to extract it."
1709         cd /
1710         unp $CONFIG $EXTRACTOPTIONS ; eend $?
1711       else
1712         ewarn "Sorry, could not find file config.tbz on device with label GRMLCFG." ; eend 1
1713       fi
1714
1715       SCRIPT=''
1716       SCRIPT="$(/bin/ls -1d /mnt/grml/[Gg][Rr][Mm][Ll].[Ss][Hh] 2>>$DEBUG)"
1717       if [ -n "$SCRIPT" ]; then
1718         einfo "Found script ${WHITE}${SCRIPT}${NORMAL} - trying to execute it."
1719         $SCRIPT ; eend $?
1720       fi
1721       eoutdent
1722     else
1723       einfo "Could not mount $MOUNTDEVICE to /mnt/grml - sorry." ; eend 1
1724     fi # mount $MOUNTDEVICE
1725    grep -q '/mnt/grml' /proc/mounts && umount /mnt/grml
1726  else
1727    einfo "Sorry, no device for bootoption myconfig provided. Skipping." ; eend 1
1728  fi # [ -n "$MOUNTDEVICE" ]
1729 fi # checkbootparam myconfig
1730
1731 if checkbootparam "partconf" ; then
1732  MOUNTDEVICE="$(getbootparam 'partconf' 2>>$DEBUG)"
1733  if [ -n "$MOUNTDEVICE" ]; then
1734    [ -d /mnt/grml ] || mkdir /mnt/grml
1735    mount -o ro -t auto $MOUNTDEVICE /mnt/grml ; RC="$?"
1736     if [[ $RC == 0 ]]; then
1737       einfo "Successfully mounted $MOUNTDEVICE to /mnt/grml (readonly)." ; eend 0
1738       einfo "Copying files from $MOUNTDEVICE over grml system."
1739       for file in `cat /etc/grml/partconf` ; do
1740         [ -d /mnt/grml/$file ] && cp -a /mnt/grml/${file}* ${file} && echo "copied: $file"
1741         [ -f /mnt/grml/$file ] && cp -a /mnt/grml/${file}  ${file} && echo "copied: $file"
1742       done && eend 0
1743     else
1744       einfo "Could not mount $MOUNTDEVICE to /mnt/grml - sorry." ; eend 1
1745     fi # mount $MOUNTDEVICE
1746    grep -q '/mnt/grml' /proc/mounts && umount /mnt/grml
1747  else
1748    einfo "Sorry, no device for bootoption partconf provided. Skipping." ; eend 1
1749  fi # [ -n "$MOUNTDEVICE" ]
1750 fi
1751 }
1752 # }}}
1753
1754 # {{{ /cdrom/.*-options
1755 config_debs(){
1756 if checkbootparam "debs" ; then
1757   DEBS="$(getbootparam 'debs' 2>>$DEBUG)"
1758   einfo "Tring to install debian package(s) ${DEBS}"
1759   dpkg -i /cdrom/debs/$DEBS* ; eend $?
1760 fi
1761 }
1762
1763 config_scripts(){
1764 if checkbootparam "scripts" ; then
1765   SCRIPTS="$(getbootparam 'scripts' 2>>$DEBUG)"
1766   [ -z "$SCRIPTS" ] && SCRIPTS='grml.sh'
1767   einfo "Bootparameter scripts found. Trying to execute ${SCRIPTS}:"
1768   sh -c /cdrom/scripts/$SCRIPTS ; eend $?
1769 fi
1770 }
1771 # }}}
1772
1773 # {{{ distcc
1774 config_distcc(){
1775 if checkbootparam "distcc" ; then
1776  OPTIONS="$(getbootparam distcc 2>>$DEBUG)"
1777  if [ -n "$OPTIONS" ]; then
1778     NET=""
1779     INTERFACE=""
1780     if [ -n "$OPTIONS" ]; then
1781       NET="${OPTIONS%%,*}"
1782       R="${OPTIONS#*,}"
1783       if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
1784         OPTIONS="$R"
1785         INTERFACE="${OPTIONS%%,*}"
1786         R="${OPTIONS#*,}"
1787       fi
1788     fi
1789  fi
1790  CONFIG=/etc/default/distcc
1791  sed -i "s#^STARTDISTCC=.*#STARTDISTCC=YES#"  $CONFIG
1792  sed -i "s#^ALLOWEDNETS=.*#ALLOWEDNETS=$NET#" $CONFIG
1793
1794  if [ -n "$INTERFACE" ] ; then
1795    IP=$(LANG=C ifconfig $INTERFACE | gawk -F: /"inet addr"/'{print $2}' | gawk '{print $1}')
1796
1797    counter=10
1798    while [ -z "$IP" ] && [[ "$counter" != 0 ]] ; do
1799      counter=$(( counter-1 ))
1800      ewarn "No ip address for $INTERFACE found. Sleeping for 3 seconds. $counter tries left."
1801      sleep 3
1802      IP=$(LANG=C ifconfig $INTERFACE | gawk -F: /"inet addr"/'{print $2}' | gawk '{print $1}')
1803    done
1804  fi
1805
1806  if [ -n "$IP" ] ; then
1807    sed -i "s#^LISTENER=.*#LISTENER=$IP#"      $CONFIG
1808
1809    einfo "Bootoption distcc found. Preparing setup for distcc daemon."
1810    eindent
1811     id distccd >/dev/null 2>&1 || \
1812     (
1813       einfo "Creating distcc user" ; \
1814       adduser --quiet --system --ingroup nogroup --home / --no-create-home distccd ; eend $?
1815     )
1816
1817     einfo "Starting distcc for network ${NET}, listening on ${IP}."
1818    /etc/init.d/distcc start 1>/dev/null ; eend $?
1819    eoutdent
1820  else
1821    eerror "No ip address for $INTERFACE found. distcc can not be used without it." ; eend 1
1822  fi
1823 fi
1824
1825 if checkbootparam "gcc"; then
1826  GCC="$(getbootparam gcc 2>>$DEBUG)"
1827  eindent
1828  einfo "Pointing /usr/bin/gcc to /usr/bin/gcc-${GCC}."
1829  eoutdent
1830  rm -f /usr/bin/gcc
1831  ln -s /usr/bin/gcc-${GCC} /usr/bin/gcc ; eend $?
1832 fi
1833
1834 if checkbootparam "gpp"; then
1835  GPP="$(getbootparam gpp 2>>$DEBUG)"
1836  eindent
1837   einfo "Pointing /usr/bin/g++ to /usr/bin/g++-${GPP}."
1838   if [ -x /usr/bin/g++-${GPP} ] ; then
1839      rm -f /usr/bin/g++
1840      ln -s /usr/bin/g++-${GPP} /usr/bin/g++ ; eend $?
1841   fi
1842   einfo "Pointing /usr/bin/cpp to /usr/bin/cpp-${GPP}."
1843   if [ -x /usr/bin/cpp-${GPP} ] ; then
1844      rm -f /usr/bin/cpp
1845      ln -s /usr/bin/cpp-${GPP} /usr/bin/cpp ; eend $?
1846   fi
1847  eoutdent
1848 fi
1849
1850 }
1851 # }}}
1852
1853 # {{{ load modules
1854 # Notice: use it only on live-cd system, if running from harddisk please
1855 # add modules to /etc/modules and activate /etc/init.d/module-init-tools
1856 # in /etc/runlevel.conf
1857 config_modules(){
1858 MODULES_FILE=/etc/grml/modules
1859 if checkbootparam nomodules ; then
1860   ewarn "Skipping loading of modules defined in ${MODULES_FILE} as requested." ; eend 0
1861 elif [ -z "$INSTALLED" ]; then
1862  if [ -r $MODULES_FILE ] ; then
1863   einfo "Loading modules specified in ${MODULES_FILE}:"
1864   eindent
1865   grep '^[^#]' $MODULES_FILE | \
1866   while read module args; do
1867     [ "$module" ] || continue
1868       einfo "${module}"
1869       modprobe $module $args ; eend $?
1870   done
1871   eoutdent
1872  else
1873   ewarn "File $MODULES_FILE does not exist. Skipping loading of specific modules." ; eend 1
1874  fi
1875 fi
1876 }
1877 # }}}
1878
1879 # {{{ 915resolution
1880 config_915resolution(){
1881 if checkbootparam "915resolution" ; then
1882  OPTIONS="$(getbootparam 915resolution 2>>$DEBUG)"
1883   if [ -x /usr/sbin/915resolution ]; then
1884     CMD=915resolution
1885     MODE=""
1886     XRESO=""
1887     YRESO=""
1888     if [ -n "$OPTIONS" ]; then
1889       # Extra options
1890       MODE="${OPTIONS%%,*}"
1891       R="${OPTIONS#*,}"
1892       if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
1893         OPTIONS="$R"
1894         XRESO="${OPTIONS%%,*}"
1895         R="${OPTIONS#*,}"
1896         if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
1897           OPTIONS="$R"
1898           YRESO="${OPTIONS%%,*}"
1899           R="${OPTIONS#*,}"
1900         fi
1901       fi
1902     fi
1903     einfo "Running 915resolution with options ${MODE} ${XRESO} ${YRESO}."
1904     [ -n "$MODE" ] && [ -n "$XRESO"  ] && [ -n "$YRESO" ]  && ( sh -c "$CMD $MODE $XRESO $YRESO" & )
1905     eend 0
1906   fi
1907 fi
1908 }
1909 # }}}
1910
1911 # {{{ SW-RAID
1912 config_swraid(){
1913   if [ -z "$INSTALLED" ] ; then
1914   # notice: checkbootparam "forensic" is just for users who don't know how to really use the bootoption
1915   if checkbootparam 'noraid'   -o checkbootparam 'noswraid' -o \
1916      checkbootparam 'forensic' -o checkbootparam 'raid=noautodetect' ; then
1917      ewarn "Skipping SW-RAID code as requested on boot commandline." ; eend 0
1918   else
1919     if ! [ -x /sbin/mdadm ] ; then
1920        eerror "mdadm not available, can not execute it." ; eend 1
1921     else
1922
1923        # if ! egrep -qv '^(MAILADDR.*|#.*|)$' /etc/mdadm/mdadm.conf 2>>$DEBUG ; then
1924        # find out whether we have a valid configuration file already
1925        if ! grep -q ARRAY /etc/mdadm/mdadm.conf 2>>$DEBUG ; then
1926           einfo "Creating /etc/mdadm/mdadm.conf for use with mdadm."
1927           [ -r /etc/mdadm/mdadm.conf ] && mv /etc/mdadm/mdadm.conf /etc/mdadm/mdadm.conf.old
1928           MDADM_MAILADDR__='root' /usr/share/mdadm/mkconf > /etc/mdadm/mdadm.conf ; eend $?
1929         else
1930           ewarn "/etc/mdadm/mdadm.conf looks like a configured mdadm setup, will not touch it." ; eend 0
1931        fi
1932
1933        if ! checkbootparam 'swraid' ; then 
1934           eindent
1935           einfo "Just run 'Start mdadm-raid' to assemble md arrays or boot using 'swraid' as bootoption for autostart."
1936           eoutdent
1937        else
1938           einfo "Bootoption swraid found. Searching for software RAID arrays:"
1939           eindent
1940            IFSOLD=${IFS:-}
1941            IFS='
1942 '
1943            for line in $(mdadm --assemble --scan --auto=yes --symlink=no 2>&1) ; do
1944                case $line in
1945                  *'No arrays found'*)
1946                    ewarn "$line" ; eend 0
1947                    ;;
1948                  *)
1949                    einfo "$line" ; eend 0
1950                    ;;
1951                esac
1952            done
1953            IFS=$IFSOLD
1954          eoutdent
1955
1956          if [ -r /proc/mdstat ] ; then
1957             eindent
1958             MDSTAT=$(grep '^md[0-9]' /proc/mdstat)
1959             if [ -z "$MDSTAT" ] ; then
1960                ewarn "No active arrays found" ; eend 0
1961             else
1962                IFSOLD=${IFS:-}
1963                IFS='
1964 '
1965                for line in $(grep '^md[0-9]' /proc/mdstat) ; do
1966                    einfo "active arrays: $line" ; eend 0
1967                done
1968                IFS=$IFSOLD
1969             fi
1970             eoutdent
1971          fi # /proc/mdstat
1972        fi # bootoption swraid
1973
1974      fi # is /sbin/mdadm executable?
1975   fi # check for bootoptions
1976   fi # run only in live-cd mode
1977 }
1978 # }}}
1979
1980 # {{{ debnet: setup network based on an existing one found on a partition
1981 config_debnet(){
1982 if checkbootparam "debnet" ; then
1983  iszsh && setopt shwordsplit
1984  DEVICES="$(< /proc/partitions tail -n +3 | awk '{print "/dev/"$4}' | tr "\n" " ")"
1985  DEVICES="$DEVICES $(ls /dev/mapper/*)"
1986  FOUND_DEBNET=""
1987
1988  einfo "Bootoption 'debnet' found. Searching for Debian network configuration: "
1989  eindent
1990  if ! mount | grep '/mnt ' 1>/dev/null 2>&1 ; then
1991     for i in $DEVICES; do
1992      if mount -o ro -t auto "$i" /mnt >/dev/null 2>&1; then
1993          einfo "Scanning on $i"
1994        if [ -f /mnt/etc/network/interfaces ]; then
1995          einfo "/etc/network/interfaces found on ${i}" ; eend 0
1996          FOUND_DEBNET="$i"
1997          break
1998        fi
1999        umount /mnt
2000      fi
2001     done
2002
2003    if [ -n "$FOUND_DEBNET" ]; then
2004      einfo "Stopping network."
2005        pump -k 1>/dev/null 2>&1
2006        /etc/init.d/networking stop 1>/dev/null 2>&1 ; eend $?
2007      einfo "Copying Debian network configuration from $FOUND_DEBNET to running system."
2008        rm -rf /etc/network/run
2009        cp -a /mnt/etc/network /etc
2010        rm -rf /etc/network/run
2011        mkdir /etc/network/run
2012        umount /mnt ; eend $?
2013      einfo "Starting network."
2014        /etc/init.d/networking start ; eend $?
2015    else
2016      eerror "/etc/network/interfaces not found." ; eend 1
2017    fi
2018    eoutdent
2019  else
2020   eerror "Error: /mnt already mounted." ; eend 1
2021  fi
2022 fi
2023 }
2024 # }}}
2025
2026 # {{{ disable console blanking
2027 config_blanking(){
2028 if checkbootparam "noblank" ; then
2029   einfo "Bootoption noblank found. Disabling monitor blanking."
2030   setterm -blank 0 ; eend $?
2031 fi
2032 }
2033 # }}}
2034
2035 # {{{ grml2hd: automatic installation
2036 config_grml2hd(){
2037
2038 if checkbootparam "user" ; then
2039   NEWUSER=''
2040   NEWUSER="$(getbootparam 'user' 2>>$DEBUG)"
2041   sed -i "s/^NEWUSER=.*/NEWUSER=$NEWUSER/" /etc/grml2hd/config || export GRML2HD_FAIL=1
2042 fi
2043
2044 if checkbootparam "filesystem" ; then
2045   FILESYSTEM=''
2046   FILESYSTEM="$(getbootparam 'filesystem' 2>>$DEBUG)"
2047   sed -i "s/^FILESYSTEM=.*/FILESYSTEM=$FILESYSTEM/" /etc/grml2hd/config || export GRML2HD_FAIL=1
2048 fi
2049
2050 if checkbootparam "partition" ; then
2051   PARTITION=''
2052   PARTITION="$(getbootparam 'partition' 2>>$DEBUG)"
2053   # notice: the following checks whether the given partition is available, if not the skip
2054   # execution of grml2hd as it might result in data loss...
2055   if [ -r $PARTITION ] ; then
2056     sed -i "s#^PARTITION=.*#PARTITION=$PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
2057   else
2058     ewarn "Partition $PARTITION does not exist. Skipping execution of grml2hd therefore." ; eend 1
2059   fi
2060 fi
2061
2062 if checkbootparam "mbr" ; then
2063   BOOT_PARTITION=''
2064   BOOT_PARTITION="$(getbootparam 'mbr' 2>>$DEBUG)"
2065   sed -i "s#^BOOT_PARTITION=.*#BOOT_PARTITION=$BOOT_PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
2066 fi
2067
2068 if stringinstring "BOOT_IMAGE=grml2hd " "$CMDLINE" ; then
2069   cat>|/usr/bin/grml2hd_noninteractive<<EOF
2070 #!/bin/sh
2071 GRML2HD_NONINTERACTIVE='yes' grml2hd
2072 EOF
2073   chmod 755 /usr/bin/grml2hd_noninteractive
2074   einfo "Bootparameter grml2hd found. Running automatic installation via grml2hd using /etc/grml2hd/config." && eend 0
2075   if [ -z "$GRML2HD_FAIL" ] ; then
2076     screen /usr/bin/grml2hd_noninteractive ; einfo "Invoking a shell, just exit to continue booting..." ; /bin/zsh
2077   else
2078     ewarn "There was an error adjusting /etc/grml2hd/config. Skipping execution of grml2hd for security reasons." ; eend 1
2079   fi
2080 fi
2081 }
2082 # }}}
2083
2084 ### {{{ backwards compatible stuff
2085 config_environment(){
2086   ewarn "config_environment is deprecated. Please set CONFIG_ENVIRONMENT in /etc/grml/autoconfig to 'no'." ; eend 0
2087 }
2088 config_keyboard(){
2089   ewarn "config_keyboard is deprecated. Please set CONFIG_KEYBOARD in /etc/grml/autoconfig to 'no'." ; eend 0
2090 }
2091 # }}}
2092
2093 ## END OF FILE #################################################################
2094 # vim:foldmethod=marker